<?
/**
  * pei-corporations-import.php - A PHP script to scrape information about incorporated
  * companies in Prince Edward Island, Canada from www.gov.pe.ca/corporations into 
  * a local MySQL database.
  *
  * Get the MySQL table structure at opencorporations.org/source
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or (at
  * your option) any later version.
  *
  * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  * General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  * USA
  *
  * @version 1.0, November 24, 2008
  * @link http://opencorporations.org/source
  * @author Peter Rukavina <peter@rukavina.net>
  * @copyright Copyright &copy; 2008, Reinvented Inc.
  * @license http://www.fsf.org/licensing/licenses/gpl.txt GNU Public License
  */

/**
  * User configurable options.
  */

// The base URL at www.gov.pe.ca/corporations to initiate a search

$baseurl = "http://www.gov.pe.ca/corporations/index.php?txtRegNum=&txtBusName=&drpBusType=1&txtStatus=1&frommonth=01&fromday=1&fromyear=1885&tomonth=12&endday=1&toyear=2008&sortby=1&submitSearch=1&action=Search";

// MySQL database information

$db['host'] = 'localhost';
$db['user'] = ''; 			// Enter MySQL username
$db['password'] = ''; 		// Enter MySQL password
$db['database'] = '';		// Enter MySQL database name

/**
  * End of User configurable options.
  */

$DONE = 0;
$counter = 100;

while (!$DONE) {

	$geturl = $baseurl . "&max=$counter";
	print $geturl . "\n";
	$index = file_get_contents($geturl);
	$indexlines = split("\n",$index);

	$queue = array();
	foreach($indexlines as $k1 => $v1) {
		if (preg_match("/top\" width=\"20\%\"/",$v1)) {
			preg_match("/amp;REF=(.*?)&/",$v1,$matches);
			$queue[] = $matches[1];
		}
	}

	if (sizeof($queue) > 1) {
		foreach($queue as $k => $regnumber) {
			print "Processing $regnumber\n";
			ProcessFile($db,$regnumber);
		}
		$counter = $counter + 100;
	}
	else {
		$DONE = 1;
	}
}

function ProcessFile($db,$regnumber) {

	$url = "http://www.gov.pe.ca/corporations/index.php?txtSearchType=2&REF=$regnumber&action=Search";

	$html = file_get_contents($url);

	$lines = split("\n",$html);

	foreach($lines as $key => $value) {
		if (preg_match("/Entity Name:/",$value)) {
			$lookfor = "ENTITY";
		}
		else if (preg_match("/Reg Number:/",$value)) {
			$lookfor = "REGNUMBER";
		}
		else if (preg_match("/Reg Date:/",$value)) {
			$lookfor = "REGDATE";
		}
		else if (preg_match("/Last Return:/",$value)) {
			$lookfor = "LASTRETURN";
		}
		else if (preg_match("/Bus In:/",$value)) {
			$lookfor = "BUSINESSIN";
		}
		else if (preg_match("/Address:/",$value)) {
			$lookfor = "ADDRESS";
		}
		else if (preg_match("/\"6\%\"/",$value)) {
			$lookfor = "PERCENTS";
		}
		else if (preg_match("/Trade Names/",$value)) {
			$lookfor = "TRADENAMES";
		}
		else if ($lookfor == "ENTITY") {
			$data['name'] = StripDataLine($value);
			$lookfor = "";
		}
		else if ($lookfor == "REGNUMBER") {
			$data['regnumber'] = StripDataLine($value);
			$lookfor = "";
		}
		else if ($lookfor == "REGDATE") {
			$date = StripDataLine($value);
			// 11-Aug-1999
			$regdate = strtotime($date);
			$regdate = strftime("%Y-%m-%d",$regdate);
			$data['regdate'] = $regdate;
			$lookfor = "";
		}
		else if ($lookfor == "LASTRETURN") {
			$date = StripDataLine($value);
			// 11-Aug-1999
			$lastreturn = strtotime($date);
			$lastreturn = strftime("%Y-%m-%d",$lastreturn);
			$data['lastreturn'] = $lastreturn;
			$lookfor = "";
		}
		else if ($lookfor == "BUSINESSIN") {
			$data['businessin'] = StripDataLine($value);
			$lookfor = "";
		}
		else if ($lookfor == "ADDRESS") {
			$value = str_replace("<BR>","\n",$value);
			$address = StripDataLine($value);
			$address = br2nl($address);
			$data['address'] = $address;
			$lookfor = "";
		}
		else if ($lookfor == "TRADENAMES") {
			// <tr><td valign="top"><font class="data">THE INNS ON GREAT GEORGE                                                                                 <br>THE GREAT GEORGE<br>THE ISLANDER MOTOR LODGE<br>THE ISLANDER<br></font></td></tr>
			$tradenames = str_replace("<br>","~",$value);
			$tradenames = StripDataLine($tradenames);
			if ($tradenames <> '') {
				$tnames = explode("~",$tradenames);
				foreach ($tnames as $k => $v) {
					$tn = trim(rtrim($v));;
					if ($tn <> '') {
						$data['tradenames'][] = $tn;
					}
				}
			}
			$lookfor = "";
		}
		else if ($lookfor == "PERCENTS") {
			$lookfor = "DIRECTORS";
			$directorline = 1;
		}
		else if (($lookfor == "DIRECTORS") and ($directorline == 1)) {
			$directorline++;
		}
		else if (($lookfor == "DIRECTORS") and ($directorline == 2)) {
			$currentdirector = array();
			$currentdirector['name'] = StripDataLine($value);
			$directorline++;
		}
		else if (($lookfor == "DIRECTORS") and ($directorline == 3)) {
			$currentdirector['position'] = StripDataLine($value);
			$directorline++;
		}
		else if (($lookfor == "DIRECTORS") and ($directorline == 4)) {
			$x = StripDataLine($value);
			if ($x == "X") {
				$currentdirector['shareholder'] = 'Y';
			}
			else {
				$currentdirector['shareholder'] = 'N';
			}
			$directorline++;
		}
		else if (($lookfor == "DIRECTORS") and ($directorline == 5)) {
			$x = StripDataLine($value);
			if ($x == "X") {
				$currentdirector['director'] = 'Y';
			}
			else {
				$currentdirector['director'] = 'N';
			}
			$directorline++;
		}
		else if (($lookfor == "DIRECTORS") and ($directorline == 6)) {
			$x = StripDataLine($value);
			if ($x == "X") {
				$currentdirector['officer'] = 'Y';
			}
			else {
				$currentdirector['officer'] = 'N';
			}
			$directorline++;
		}
		else if (($lookfor == "DIRECTORS") and ($directorline == 7)) {
			$directorline++;
		}	
		else if (($lookfor == "DIRECTORS") and ($directorline == 8)) {
			$currentdirector['address'] = StripDataLine($value);
			$directorline++;
		}	
		else if (($lookfor == "DIRECTORS") and ($directorline == 9)) {
			if (trim($value) == "</table></td></tr>") {
				$data['officers'][] = $currentdirector;
				$lookfor = "";
			}
			else {
				$data['officers'][] = $currentdirector;
				$directorline = 2;
			}
		}
	}

	MYSQL_CONNECT($db['host'],$db['user'],$db['password']);
	MYSQL_SELECT_DB( $db['database'] ) or die( "Unable to select database");

	$query = "INSERT into corporations (regnumber,name,regdate,lastreturn,businessin,address) values (
			'" . addslashes($data['regnumber']) . "',
			'" . addslashes($data['name']) . "',
			'" . addslashes($data['regdate']) . "',
			'" . addslashes($data['lastreturn']) . "',
			'" . addslashes($data['businessin']) . "',
			'" . addslashes($data['address']) . "')";
			
	$result = MYSQL_QUERY($query);

	foreach($data['officers'] as $okey => $officer) {
		$query = "INSERT into officers (regnumber,name,position,shareholder,director,officer,address) values (
			'" . addslashes($data['regnumber']) . "',
			'" . addslashes($officer['name']) . "',
			'" . addslashes($officer['position']) . "',
			'" . addslashes($officer['shareholder']) . "',
			'" . addslashes($officer['director']) . "',
			'" . addslashes($officer['director']) . "',
			'" . addslashes($officer['address']) . "')";
		$result = MYSQL_QUERY($query);
	}	

	foreach($data['tradenames'] as $tnkey => $tradename) {
		$query = "INSERT into tradenames (regnumber,tradename) values (
			'" . addslashes($data['regnumber']) . "',
			'" . addslashes($tradename) . "')";
			
		$result = MYSQL_QUERY($query);
	}	


	print($data['name'] . "\n");
}

function br2nl($string) {
	return str_replace('\<BR\>', "\n", $string);
}

function StripDataLine($target) {
	
	$target = rtrim(trim(strip_tags($target)));
	$target = html_entity_decode($target);
	
	return $target;
}